angular.module('wsmob.controllers', [])
.controller('AuthCtrl', function($scope, $state, $http, $ionicPopup, $ionicLoading, UserService) {   
 /* --------------------------------------------  
 | Controller used to initliase app and check a users cedentials   
 */   
 /* validate user credentials */    
 $scope.validateUser = function(){     
    console.log('AuthCtrl $scope.validateUser');   
    UserService.validateCookie()
                .then(function(data) {
                    // connnected to server
                    console.log('UserService.validateCookie data returned to controller.', data); 
                    if(data.valid){
                        // credentails okay go to dashboard
                        //UserService.getUser();
                        $state.go('app.dashboard');
                    }else{
                        // credentials not valid go to sign in
                        $state.go('signin');
                    }
                }, 
                function(data) {
                   // could not connnect to server - show error 
                   console.log('UserService.validateCookie data retrieval failed.', data);                    
                   var alertPopup = $ionicPopup.alert({
                        title: 'Auth Error!',
                        template: data.error
                   });  
                   // retry authorisation
                   alertPopup.then(function(res) {                          
                        $scope.validateUser(); 
                   });                   
                });
  };            
  $scope.validateUser();  // validate user  
})
.controller('SignInCtrl', function($scope, $state, $http, $ionicPopup, $ionicLoading, UserService, DashService) {
 /* --------------------------------------------  
 | Controller used to sign a user in 
 */    
    // initialise user object
    $scope.user = {};  
    // preset values for testing    
    //$scope.user.username = 'user1';  
    //$scope.user.password = 'overout2097';  
    $scope.user.username = '';  
    $scope.user.password = '';  
    UserService.resetUser();
    
    
    // authorise users sign details
    $scope.signIn = function(user) {
        console.log('SignInCtrl $scope.signIn', user);   

        // submit user details to api
        UserService.signIn(user.username, user.password)
        .then(function(data) {        
                    console.log('SignInCtrl UserService.signIn data returned to controller.', data); 
                    // reset schedules
                    //DashService.resetSchedules();         
                    // //$ionicLoading.hide();
                    // goto dash
                    //$state.go('app.dashboard');
                     //UserService.getUser();
                     $state.go('app.dashboard', {}, {reload: true});
                },
                function(data) {
                    // could not connnect to server - show error 
                    console.log('SignInCtrl UserService.signIn error data not returned', data);
                    //
                    var alertPopup = $ionicPopup.alert({
                     title: 'Auth Error!',
                     template: data.error
                   });    
                   // retry signin
                   /*alertPopup.then(function(res) {                         
                       $scope.signIn(user); 
                   });   */
                });                
    };
})
.controller('SignUpCtrl', function($scope, $state, $http, $ionicPopup, $ionicLoading, UserService) {
 /* --------------------------------------------  
 | Controller used to handle new user sign ups
 */       
    // initialise user object
    $scope.user = {};  
    
    // preset values for testing 
    //$scope.user.username = 'user1';  
    //$scope.user.password = 'overout2097';  
    $scope.user.username = '';  
    $scope.user.password = '';      
    $scope.user.email    = '';
    
    // sign up user
    $scope.signUp = function(user) {
        console.log('SignUpCtrl $scope.signUp', user);    

        // submit new user details to api
        UserService.signUp(user.username, user.password, user.email)
        .then(function(data) {
                    console.log('UserService.signUp data returned to controller.', data);
                    var alertPopup = $ionicPopup.alert({
                                 title: 'Signup Successful!',
                                 template: "To start using the Workout Scheduler app please check your email and confirm your new account. After confirmation you will then be able to sign in."
                               });
                                // goto signin
                                alertPopup.then(function(res) {                                      
                                    //$state.go('signin');
                                     $state.go('signin', {}, {reload: true});
                                });    
                },
                function(data) {
                    // could not create account - show error 
                    console.log('UserService.signUp error data not returned', data);
                   // 
                    var alertPopup = $ionicPopup.alert({
                     title: 'Sign Up Error!',
                     template: data.error
                   });    
                   // retry signUp
                  /* alertPopup.then(function(res) {                         
                       $scope.signUp(user); 
                   });                     */
                });                
    };
})
.controller('PasswordCtrl', function($scope, $state, $http, $ionicPopup, $ionicLoading, UserService) {
 /* --------------------------------------------  
 | Controller used to recover existing user passwords
 */      
    // initialise user object
    $scope.user = {};      
    // preset values for testing 
    //$scope.user.username = 'user1'; 
    $scope.user.username = ''; 
    
    // recover users password
    $scope.recoverPassword = function(user) {
        console.log('PasswordCtrl $scope.recoverPassword', user);        
        console.log(user.username);

         // submit accounts details to api
        UserService.recoverPassword(user.username)
        .then(function(data) {
                    // connnected to server and recovery details have been emailed - show confirmation
                    console.log(' UserService.recoverPassword data returned to controller.', data);
                    //$ionicLoading.hide();// hide loading icon
                    var alertPopup = $ionicPopup.alert({
                     title: 'Password Sent!',
                     template: 'Your password reminder has been emailed to you.'
                   });                       
                },
                function(data) {
                    // could not recover account - show error 
                    console.log('UserService.recoverPassword error data not returned', data);
                    //$ionicLoading.hide();// hide loading icon
                    var alertPopup = $ionicPopup.alert({
                     title: 'Password Error!',
                     template: data.error
                   });    
                   // retry recover pass
                  /* alertPopup.then(function(res) {                         
                       $scope.recoverPassword(user); 
                   });  */
                });
    };
}) 
.controller('AppCtrl', function($scope, $ionicSideMenuDelegate, $state, $ionicPopup, UserService) {  
  /* --------------------------------------------  
 | Main application controller - can be used to define shared functions among child scopes
 */  
    
    // toogle left menu
    $scope.toggleLeft = function() {
        console.log('AppCtrl toggle left');
        $ionicSideMenuDelegate.toggleLeft();
    };
    // toogle right menu
    $scope.toggleRight = function() {
        console.log('AppCtrl toggle right');
        $ionicSideMenuDelegate.toggleRight();
    };
  
    // user sign out function
    $scope.signOut = function() {
        console.log('AppCtrl $scope.signOut');
        // check user wants to sign out
        var signOutPopup = $ionicPopup.confirm({
             title: 'Sign Out',
             template: 'Are you sure you want to sign out?'
           });
           signOutPopup.then(function(confirm) {
             if(confirm) {
               // user confirmed signout - destroy stored user 
               console.log('signOutPopup - confirmed');
               if(UserService.signOut()){
                   //$state.go('signin'); // return to sign in
                   $state.go('signin', {}, {reload: true});
               }
             } else {
                // do nothing
               console.log('signOutPopup - cancelled');
             }
           });        
    };  
})   
.controller('DashCtrl', function($scope, $state,  $ionicPopup, $ionicLoading, $ionicActionSheet, DashService, UserService, ScheduleService){//, scheduleData) { 
 /* --------------------------------------------  
 | Dashboard controller displays and manages a users schedules
 */ 
    // reset schedules
    //DashService.resetSchedules();     
    $scope.data = {};
    // console.log('DashCtrl', $scope.data);
    $scope.hideEmpty = {}; 
    $scope.hideEmpty.status = true;
     
    // used to determine the card lists display class
    $scope.cardClass = function(completed) {
        var className = 'card-calm';
        if (completed == '0')
            className = 'card-dark';
        if (completed == '100')
            className = 'card-positive';
        return className;
    };
    
    // update dashboard schedules
    /**/
    function updateSchedules() {
        //if(window.AdMob) window.AdMob.showInterstitial();
        console.log('DashCtrl update schedules');        
        
        // update schedules    
        DashService.updateSchedules()
                    .then(function(data) {
                        // connnected to server - show schedule
                        console.log('DashService.updateSchedules data returned to controller.', data, DashService.schedulesData);
                        //$ionicLoading.hide();
                        $scope.data = DashService.schedulesData;  // init schedule data object
                        if($scope.data.hasOwnProperty('schedules') && $scope.data.schedules.length > 0){
                              $scope.hideEmpty.status  = true;
                           }else{
                               $scope.hideEmpty.status  = false;
                           }
                    },
                    function(data) {
                        // could not update/retrieve schedules - show error 
                        console.log('DashService.updateSchedules data retrieval failed.', data);
                        $ionicLoading.hide();// hide loading icon
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        });  
                        // retry update schedules
                        alertPopup.then(function(res) {
                            updateSchedules();
                        });
                    });
    }
    updateSchedules(); // call schedule update function                    
    

    // individual schedule actionsheet/options
    $scope.showActionsheet = function (schedule) {        
        $ionicActionSheet.show({
          titleText: schedule.title, 
          buttons: [
            {
              text: '<i class="icon left ion-ios-search"></i>  View'
            }
          ],
          destructiveText: '<i class="icon ion-ios-trash-outline"></i> Delete',
          cancelText: '<i class="icon ion-ios-close-outline"></i> Cancel',
          cancel: function () {
            // do nothing  
            console.log('CANCELLED');
          },
          buttonClicked: function (index) {
            // view schedule  
            console.log('BUTTON CLICKED', index);
            if(index === 0){
                $scope.viewSchedule(schedule);
            }
            return true;
          },
          destructiveButtonClicked: function () {
            // delete schedule  
            console.log('DESTRUCT', schedule);
            $scope.removeSchedule(schedule);
            return true;
          }
        });        
    };
    
    // remove schedule
    $scope.removeSchedule = function(schedule) {         
        // confirm the delete
        var schedulePopup = $ionicPopup.confirm({
             title: 'Confirm Delete',
             template: 'Are you sure you want to delete '+schedule.title+'?'
        });       
        schedulePopup.then(function(confirm) {
              if(confirm) {
                    // schedule delete confirmed
                    console.log('DashCtrl $scope.removeSchedule - confirmed');  
                    // connect to api to remove schedule form DB
                    ScheduleService.deleteSchedule(schedule)
                    .then(function(data) {
                            // connnected to server, schedle dleted - update workouts
                            console.log('DashCtrl ScheduleService.deleteSchedule data returned to controller.',data);                            
                            DashService.updateSchedules()
                                .then(function(data2) {
                                    // workouts updated
                                    console.log('DashCtrl DashService.updateSchedules data returned to controller.', data2);
                                    //$scope.data = DashService.schedulesData;
                                    //$state.go($state.current, {}, {reload: true});
                                    var index =  $scope.data.schedules.indexOf(schedule);
                                    $scope.data.schedules.splice(index, 1);  
                                    
                                    if($scope.data.hasOwnProperty('schedules') && $scope.data.schedules.length > 0){
                                       $scope.hideEmpty.status  = true;
                                    }else{
                                        $scope.hideEmpty.status  = false;
                                    }
                                },
                                function(data2) {
                                    // could not update workouts - show error
                                    console.log('DashCtrl ScheduleService.deleteSchedule data retrieval failed.', data2);
                                    var alertPopup = $ionicPopup.alert({
                                        title: 'Data Error!',
                                        template: data.error
                                    });   
                                    // retry removeSchedule
                                   /* alertPopup.then(function(res) {                                  
                                        $scope.removeSchedule(schedule); 
                                    });      */
                                });                       
                        },
                        function(data) {
                             // could not delete schedule - show error
                            console.log('ScheduleWorkoutCtrl ScheduleService.updateScheduleWorkouts data retrieval failed.',data);                           
                            var alertPopup = $ionicPopup.alert({
                                title: 'Data Error!',
                                template: data.error
                            }); 
                            // retry removeSchedule
                           /* alertPopup.then(function(res) {                                  
                                $scope.removeSchedule(schedule); 
                            });                            */
                    });                 
              } else {
                  // delete cancelled - do nothing
                  console.log('DashCtrl $scope.removeSchedule - cancelled');
              } 
        });             
    };  
   
    // view a schedule 
    $scope.viewSchedule = function(schedule) {
        console.log('DashCtrl $scope.viewSchedule');          
        ScheduleService.setSchedule(schedule); // set service schedule
        ScheduleService.getScheduleData() // retrieve schedule data from api
        .then(function(data) {
            // connnected to server - redirect to schedule details
            console.log('ScheduleService.getScheduleData data returned to controller.', data);            
            //$ionicLoading.hide();// hide loading icon
            $state.go('app.schedule.workouts');                                
         },
        function(data) {
            // could not retrieve schedule - show error 
            console.log('ScheduleService.getScheduleData data retrieval failed.', data);
            //$ionicLoading.hide();// hide loading icon
            var alertPopup = $ionicPopup.alert({
                title: 'Data Error!',
                template: data.error
            });      
            // retry viewSchedule
            /*alertPopup.then(function(res) {                  
                $scope.viewSchedule(schedule); 
            });            */
        });  
    };     
})   
.controller('ProfileCtrl', function($scope, $state, $ionicPopup, $ionicLoading, $filter, UserService){//, settings) {    
 /* --------------------------------------------  
 | Controller manages user and app settings
 */ 
   
    //$scope.user = UserService.getUser(); // retrive user data
    //$scope.settings = settings;  
    $scope.settings = {
                        height : 0,
                        units : 'lb/in',
                        gender : 'female',
                        dob : new Date()
                      };
    
    $scope.updateSettings = function(){   
        console.log($scope.settings);  
    };

    // before we exit - connect to api and save changes
    $scope.$on('$ionicView.beforeLeave', function(){    
        UserService.setSettings($scope.settings)
                .then(function(data) {
                        // connnected to server - settings updated
                        console.log('UserService.setSettings() data returned to controller.', data);
                        //$scope.settings = data;  
                         $scope.settings = UserService.settings;  
                    },
                    function(data) {
                        // could not update settings  - show error
                        console.log('UserService.setSettings() data retrieval failed.', data);                       
                       /* var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        });   */
                    });
    });

    // view a users settings 
    function viewSettings() {
        console.log('DashCtrl update schedules');
            UserService.getSettings()
                    .then(function(data) {
                        // connnected to server - settings retrieved
                        console.log('UserService.getSettings() data returned to controller.', data);
                        //$ionicLoading.hide();// hide loading icon
                        $scope.settings = data;  
                    },
                    function(data) {
                        // could not get settings  - show error
                        console.log('UserService.getSettings() data retrieval failed.', data);
                        //$ionicLoading.hide();// hide loading icon
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        }); 
                        // retry signin
                        alertPopup.then(function(res) {                              
                            $scope.viewSettings(); 
                        }); 
                    });
    }
    viewSettings(); // call viewsetting function     
})  
.controller('ScheduleWorkoutCtrl', function($scope, $state, $ionicPopup, $ionicLoading, $ionicSlideBoxDelegate,  $ionicScrollDelegate, ScheduleService, DashService) {
 /* --------------------------------------------  
 | Controller manages user schedule workout record
 */       
    // slidebox functions  
    // disbale swipe on slide box - use footer arrows instead
    $scope.disableSwipe = function() {
        $ionicSlideBoxDelegate.enableSlide(false);
    };
    // next slide function
    $scope.nextSlide = function() {
         $ionicScrollDelegate.scrollTop(); // scroll top
         // switch slides
         $ionicSlideBoxDelegate.enableSlide(true);
         $ionicSlideBoxDelegate.next();
         $ionicSlideBoxDelegate.enableSlide(false);
    };
    // previous slide function
    $scope.prevSlide = function() {
        $ionicScrollDelegate.scrollTop(); // scroll top
        // switch slides
        $ionicSlideBoxDelegate.enableSlide(true);
        $ionicSlideBoxDelegate.previous();
        $ionicSlideBoxDelegate.enableSlide(false);
    };    
    // slide changed function
    $scope.slideChanged = function(slide, weeks){
        console.log(slide);
        $scope.slideIndex = slide+1;        
    };
    
    // convert a string to date format
    $scope.convertDate = function(date){
        return new Date(date);
    };
    
    // record workout
    $scope.logWorkout = function(workout){     
        // create/update logged date
        var d = new Date();
        var curr_date = d.getDate();
        var curr_month = d.getMonth() + 1; //Months are zero based
        var curr_year = d.getFullYear();        
        var curr_hour = d.getHours();        
        var curr_minutes = d.getMinutes();              
        workout.logged = curr_year + "-" + curr_month + "-" + curr_date + ' ' + curr_hour + ':' + curr_minutes + ':00';
        console.log('ScheduleWorkoutCtrl $scope.logWorkout ', $scope.scheduleData); 
        console.log('ScheduleWorkoutCtrl $scope.logWorkout ',ScheduleService.scheduleData); 
        
        // update schedule via api
        ScheduleService.updateScheduleWorkouts()        
        .then(function(data) {
                            // connnected to server - schedule workout updated
                            console.log('ScheduleWorkoutCtrl ScheduleService.updateScheduleWorkouts data returned to controller.',data);
                            // update dashboard schedules - to display correct percentage of completion
                            DashService.updateSchedules()
                                .then(function(data2) {
                                    // connnected to server - schedules updated
                                    console.log('scheduleWorkoutCtrl DashService.updateSchedules data returned to controller.', data2);
                                },
                                function(data2) {
                                    // could not update schedules - show error
                                    console.log('scheduleWorkoutCtrl DashService.updateSchedules data retrieval failed.', data2);
                                    var alertPopup = $ionicPopup.alert({
                                        title: 'Data Error!',
                                        template: data.error
                                    });   
                                    // retry update
                                    /*alertPopup.then(function(res) {                              
                                        $scope.logWorkout(workout); 
                                    }); */
                                });                       
                        },
                        function(data) {
                            // could not update schedule workouts - show error
                            console.log('ScheduleWorkoutCtrl ScheduleService.updateScheduleWorkouts data retrieval failed.',data);                           
                            var alertPopup = $ionicPopup.alert({
                                title: 'Data Error!',
                                template: data.error
                            }); 
                            // retry update
                           /* alertPopup.then(function(res) {                              
                                $scope.logWorkout(workout); 
                            });                             */
                    });          
    };
    // function to update schedule view
    function initWorkouts(){
        // initialise schedule variables
        $scope.scheduleData = ScheduleService.scheduleData;   
        $scope.slideIndex = 1;
        $scope.slideWeeks = $scope.scheduleData.schedule.weeks.length;        
        $ionicSlideBoxDelegate.update(); // update dynamic slidebox
        console.log('ScheduleWorkoutCtrl updateSchedule', $scope.scheduleData);   
    }    
    initWorkouts();// call update function   
    
})
.controller('ScheduleStatsCtrl', function($scope, $state, $ionicPopup, $ionicModal, $ionicLoading, ScheduleService, UserService, settings) {
 /* --------------------------------------------  
 | Controller manages user schedule workout stats
 */ 
    $scope.hideEmpty = true;
    
    function statsInit(){
        // init vars
        $scope.scheduleData = ScheduleService.scheduleData; // get schedule data
       // $scope.settings = settings;  
        console.log('ScheduleStatsCtrl');
        $scope.newStats = {};    

        // get user settings
         UserService.getSettings()
                    .then(function(data) {
                        // stats retrieved
                        console.log('UserService.getSettings() data returned to controller.', data);
                        //$scope.settings = data;  
                        $scope.settings = UserService.settings;
                    },
                    function(data) {
                        // could not get stats - show error
                        console.log('UserService.getSettings() data retrieval failed.', data);
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        });  
                        // retry init
                        alertPopup.then(function(res) {                              
                             statsInit();
                        }); 
                    });        
        /**/
        console.log('ScheduleStatsCtrl', $scope.scheduleData, $scope.settings);
    };
    statsInit();
    
    // convert date
    $scope.convertDate = function(date){
        return new Date(date);
     };
     
    // remove stats
    $scope.removeStats = function(stat) {   
        // confirm stat removal
        var statPopup = $ionicPopup.confirm({
             title: 'Confirm Delete',
             template: 'Are you sure you want to delete these stats?'
        });       
        statPopup.then(function(confirm) {
              if(confirm) {
                    // stats removal confirmed
                    console.log('ScheduleStatsCtrl $scope.removeStats - confirmed');  
                    var index =  $scope.scheduleData.stats.indexOf(stat);
                    $scope.scheduleData.stats.splice(index, 1);   
                    
                    // connnect to server - remove stats
                    ScheduleService.updateScheduleStats();   
                    
              } else {
                    // stat removal cancelled  - do nothing
                    console.log('ScheduleStatsCtrl $scope.removeStats - cancelled');
              } 
        });             
    };
     
    // Create and load the stats Modal
     $ionicModal.fromTemplateUrl('add-stats.html', function(modal) {
       $scope.statsModal = modal;
     }, {
       scope: $scope,
       animation: 'slide-in-up'
     });

     // Called when the form is submitted
     $scope.createStats = function(newStats) {
        var d = new Date();
        var curr_date = d.getDate();
        var curr_month = d.getMonth() + 1; //Months are zero based
        var curr_year = d.getFullYear();        
        var curr_hour = d.getHours();        
        var curr_minutes = d.getMinutes();   
        var uid = d.getTime();
        newStats.logged = curr_year + "-" + curr_month + "-" + curr_date + ' ' + curr_hour + ':' + curr_minutes + ':00';
        
        // add new stats to schedule data 
        $scope.scheduleData.stats.push({                 
            weight : newStats.weight, 
            chest : newStats.chest, 
            arm : newStats.arm, 
            hips : newStats.hips, 
            waist : newStats.waist, 
            thigh : newStats.thigh,
            logged: newStats.logged
        });
        console.log($scope.scheduleData.stats);              

       
        
        // update schedule stats
       // ScheduleService.updateScheduleStats();   
         ScheduleService.updateScheduleStats()
         .then(function(data) {
                        // notes updated - reset modal/data
                        $scope.newStats.weight = ""; 
                        $scope.newStats.chest = ""; 
                        $scope.newStats.arm = ""; 
                        $scope.newStats.hips = ""; 
                        $scope.newStats.waist = ""; 
                        $scope.newStats.thigh = "";  
                         // hide modal
                        $scope.statsModal.hide();
                    },
                    function(data) {
                         // could not connnect to server - show error
                        console.log('ScheduleStatsCtrl createStat data retrieval failed.');   
                        $scope.scheduleData.stats.pop();// update failed - remove new stats item from array
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        }); 
                    });        
     };

     // open our add stats modal
     $scope.addStats = function() {
       $scope.newStats.weight = ""; 
       $scope.newStats.chest = ""; 
       $scope.newStats.arm = ""; 
       $scope.newStats.hips = ""; 
       $scope.newStats.waist = ""; 
       $scope.newStats.thigh = "";        
       $scope.statsModal.show();       
     };

     // close the stats modal
     $scope.closeNewStats = function() {         
       $scope.statsModal.hide();
     };                 
})
.controller('ScheduleNotesCtrl', function($scope, $state, $ionicPopup, $ionicModal, $ionicLoading, ScheduleService) {
/* --------------------------------------------  
 | Controller manages user schedule workout notes
 */ 
    $scope.hideEmpty = true;
 
   // init notes
    function notesInit(){       
        $scope.scheduleData = ScheduleService.scheduleData; 
        $scope.newNote = {};    
    };
    notesInit();
    
    // convert date
    $scope.convertDate = function(date){
        return new Date(date);
    };
    
    // remove notes
    $scope.removeNote = function(note) { 
         // confirm note removal
        var notePopup = $ionicPopup.confirm({
             title: 'Confirm Delete',
             template: 'Are you sure you want to delete these notes?'
        });    
        notePopup.then(function(confirm) {
              if(confirm) {
                    // notes removal confirmed
                    console.log('ScheduleNotesCtrl $scope.removeNote - confirmed');  
                    var index =  $scope.scheduleData.notes.indexOf(note);
                    $scope.scheduleData.notes.splice(index, 1);  
                    // connnect to server - remove notes
                    ScheduleService.updateScheduleNotes();      
              } else {
                    // note removal cancelled  - do nothing
                    console.log('ScheduleNotesCtrl $scope.removeNote - cancelled');
              } 
        });            
    };
    
    
    // create and load the note modal
     $ionicModal.fromTemplateUrl('add-note.html', function(modal) {
       $scope.noteModal = modal;
     }, {
       scope: $scope,
       animation: 'slide-in-up'
     });

     // called when the form is submitted
     $scope.createNote = function(newNote) {
        var d = new Date();
        var curr_date = d.getDate();
        var curr_month = d.getMonth() + 1; //Months are zero based
        var curr_year = d.getFullYear();        
        var curr_hour = d.getHours();        
        var curr_minutes = d.getMinutes();   
        var uid = d.getTime();
        newNote.logged = curr_year + "-" + curr_month + "-" + curr_date + ' ' + curr_hour + ':' + curr_minutes + ':00';
        
        // add new note to schedule data 
        $scope.scheduleData.notes.push({      
         logged: newNote.logged,
         note: newNote.note
        });
        console.log($scope.scheduleData.notes);

       
        // update schedule notes
        //ScheduleService.updateScheduleNotes(); 
        ScheduleService.updateScheduleNotes()
         .then(function(data) {
                        // notes updated - reset modal/data
                        newNote.note = "";
                        // hide modal
                        $scope.noteModal.hide();
                    },
                    function(data) {
                         // could not connnect to server - show error
                        console.log('ScheduleNotesCtrl createNote data retrieval failed.');   
                        $scope.scheduleData.notes.pop();// update failed - remove new note item from array
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        }); 
                    });
     };

     // open our new note modal
     $scope.addNote = function() {
       $scope.newNote.note = "";  
       $scope.noteModal.show();
     };

     // close the note modal
     $scope.closeNewNote = function() {         
       $scope.noteModal.hide();
     };      
})
.controller('CalsCtrl', function($scope, $state, $http, $ionicPopup, $ionicLoading, UserService, CalendarService) {
/* --------------------------------------------  
 | Controller display list of available calendars to schedule
 */ 
    $scope.hideEmpty = {}; 
    $scope.hideEmpty.status = true;
    
    // refresher
    $scope.calRefresh = function() {    
        console.log('Refreshing!');       
          updateCalendars();
          //Stop the ion-refresher from spinning
          $scope.$broadcast('scroll.refreshComplete');
      };
    // view a calendar
    $scope.viewCalendar = function(calendar) {
        CalendarService.setCalendar(calendar); // set calendar to view
        $state.go('app.calendar'); // goto calendar details
    };   
    
    // update calendar list
    function updateCalendars() {
        // get available user calendars from api   
        CalendarService.getCalendars()
                   .then(function(data) {
                        // connnected to server - show calendars
                        console.log('CalsCtrl CalendarService.getCalendars data returned to controller.');                        
                        $scope.calendars = CalendarService.calendarsData.calendars;
                        
                        //$scope.data = DashService.schedulesData;  // init schedule data object
                        if($scope.calendars.length > 0){
                            $scope.hideEmpty.status  = true;
                         }else{
                             $scope.hideEmpty.status  = false;
                         }         
                    },
                    function(data) {
                         // could not connnect to server - show error
                        console.log('CalsCtrl CalendarService.getCalendars data retrieval failed.');                        
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        }); 
                        // retry update
                        alertPopup.then(function(res) {                              
                             updateCalendars();
                        }); 
                    });
    }
    updateCalendars();   // call update function
    
        
})
.controller('CalCtrl', function($scope, $state, $http, $ionicModal, $ionicPopup, $ionicLoading, $ionicSlideBoxDelegate,  $ionicScrollDelegate, UserService, DashService, CalendarService) {
/* --------------------------------------------  
 | Controller display list of available calendars to schedule
 */  
     // slidebox functions  
    // disbale swipe on slide box - use footer arrows instead
    $scope.disableSwipe = function() {
        $ionicSlideBoxDelegate.enableSlide(false);
    };
    // next slide function
    $scope.nextSlide = function() {
         $ionicScrollDelegate.scrollTop(); // scroll top
         // switch slides
         $ionicSlideBoxDelegate.enableSlide(true);
         $ionicSlideBoxDelegate.next();
         $ionicSlideBoxDelegate.enableSlide(false);
    };
    // previous slide function
    $scope.prevSlide = function() {
        $ionicScrollDelegate.scrollTop(); // scroll top
        // switch slides
        $ionicSlideBoxDelegate.enableSlide(true);
        $ionicSlideBoxDelegate.previous();
        $ionicSlideBoxDelegate.enableSlide(false);
    };    
    // slide changed function
    $scope.slideChanged = function(slide, weeks){
        console.log(slide);
        $scope.slideIndex = slide+1;        
    };
   
    // return to calendars
    $scope.goBack = function(){
        $state.go('app.calendars');
    };
    
    // init calendar 
    function initCalendar() {  
        // get calendar data from api    
        CalendarService.getCalendarData()
                    .then(function(data) {
                        // connnected to server - show calendar
                        console.log('CalCtrl CalendarService.getCalendarData data returned to controller.', data);
                        //$ionicLoading.hide();// hide loading icon
                        // init vars
                        $scope.calendarData = CalendarService.calendarData;
                        $scope.slideIndex = 1;
                        $scope.slideWeeks =  $scope.calendarData.calendar.weeks.length;
                        $ionicSlideBoxDelegate.update(); // update dynamic slidebox
                    },
                    function(data) {
                         // could not connnect to server - show error
                        console.log('CalCtrl CalendarService.getCalendarData data retrieval failed.', data);
                        //$ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: 'Data Error!',
                            template: data.error
                        });                           
                         // retry update
                        alertPopup.then(function(res) {                              
                             initCalendar();
                        }); 
                    });
    }
    initCalendar();  // call init function   
    
    // add a new schedule
    $scope.addSchedule = function() {
        // confirm schedule to be added
         var schedulePopup = $ionicPopup.confirm({
             title: 'Schedule Programme', 
             template: 'Are you sure you want to schedule '+$scope.calendarData.title+'?'
        });       
        // set new schedule calendar data via api   
        schedulePopup.then(function(confirm) {
              if(confirm) {
                    // add schedule cnfirmed - create schedule
                    console.log('CalCtrl $scope.addSchedule - confirmed');                      
                    // create the schedule
                    CalendarService.createSchedule()
                                .then(function(data) {
                                    console.log('CalCtrl CalendarService.createSchedule data returned to controller.', data);
                                    // connnected to server - update schedules
                                    DashService.updateSchedules()
                                    .then(function(data2) {
                                        // connnected to server - return to dash
                                        console.log('CalCtrl DashService.updateSchedules data returned to controller', data2);
                                        //$ionicLoading.hide();
                                        $state.go('app.dashboard');
                                    },
                                    function(data2) {
                                        // could not create schedule - show error
                                        //$ionicLoading.hide();
                                        console.log('CalCtrl DashService.updateSchedules  data retrieval failed.', data2)
                                        //$ionicLoading.hide();
                                        var alertPopup = $ionicPopup.alert({
                                            title: 'Data Error!',
                                            template: data.error
                                        });         
                                        // retry schedule create
                                       /* alertPopup.then(function(res) {                              
                                             $scope.addSchedule();
                                        }); */
                                    }); 
                                },
                                function(data) {
                                    // could not connect to server - show error
                                    console.log('CalCtrl CalendarService.createSchedule data retrieval failed.', data);
                                    //$ionicLoading.hide();
                                    var alertPopup = $ionicPopup.alert({
                                        title: 'Data Error!',
                                        template: data.error
                                    }); 
                                    // retry schedule create
                                    /*alertPopup.then(function(res) {                              
                                         $scope.addSchedule();
                                    });                                     */
                                });   
              } else {
                    // new schedule cancelled  - do nothing
                    console.log('CalCtrl $scope.addSchedule  - cancelled');
              } 
        });         
    };
});