angular.module('wsmob.filters', [])
.filter('weightLabel', function () {
 /* --------------------------------------------  
 | Filter creates weigth label based on supplied units setting
 */ 
    return function (units) {
        if(units === 'kg/cm'){
            return '(kg)';
        }else{
            return '(lb)';
        }
    };
})
.filter('lengthLabel', function () {
/* --------------------------------------------  
 | Filter creates length label based on supplied units setting
 */ 
    return function (units) {
        if(units === 'kg/cm'){
            return '(cm)';
        }else{
            return '(in)';
        }
    };
})
.filter('weightConvert', function () {
/* --------------------------------------------  
 | Filter converts weight based on supplied units setting
 */     
    return function (value, units) {
        console.log('weightConvert',value,units);
        if(units === 'kg/cm'){
            return (value / 2.20462).toFixed(1);
        }else{
            return value.toFixed(1);
        }
    };
})
.filter('lengthConvert', function () {
/* --------------------------------------------  
 | Filter converts length based on supplied units setting
 */      
    return function (value, units) { 
        console.log('lengthConvert',value,units);
        if(units === 'kg/cm'){            
            return (value * 2.54).toFixed(1);
        }else{
            return value.toFixed(1);
        }
    };
})
.filter('dateConvert', function ($filter) {
/* --------------------------------------------  
 | Filter converts date string to acceptable date
 */      
    return function (value) {
        console.log('dateConvert',value);
        //var date = Date.parseExact(value,'MM-dd-yyyy');
        //return date;
        var t = value.split(/[- :]/);
        // Apply each element to the Date function
        var d = new Date(t[0], t[1]-1, t[2], t[3], t[4], t[5]);
        var date = $filter('date')( new Date(d), "MMM dd, yyyy");
        return date.toString();
    };
});



