angular.module('wsmob.interceptors', [])
.factory('WsHttpInterceptor', function ($q, $rootScope) {
    return {
      // On request success
      request: function (config) {
         console.log('config', config); // Contains the data about the request before it is sent.
         $rootScope.$broadcast('loading:show');
         // Return the config or wrap it in a promise if blank.
         return config || $q.when(config);
      },
 
      // On request failure
      requestError: function (rejection) {
        // console.log(rejection); // Contains the data about the error on the request.
        $rootScope.$broadcast('loading:hide');
        // Return the promise rejection.
        return $q.reject(rejection);
      },
 
      // On response success
      response: function (response) {
        console.log('response',response); // Contains the data from the response.
        $rootScope.$broadcast('loading:hide');
        // Return the response or promise.
        return response || $q.when(response);
      },
 
      // On response failture
      responseError: function (rejection) {
        console.log('rejection',rejection); // Contains the data about the error.
        $rootScope.$broadcast('loading:hide');
        // Return the promise rejection.
        return $q.reject(rejection);
      }
    };
});




