// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('wsmob', ['ionic', 'wsmob.controllers', 'wsmob.services', 'wsmob.directives','wsmob.filters','wsmob.interceptors'])
.config(['$httpProvider', function ($httpProvider) {
  // Intercept POST requests, convert to standard form encoding
  $httpProvider.defaults.headers.post["Content-Type"] = "application/x-www-form-urlencoded";
  $httpProvider.defaults.transformRequest.unshift(function (data, headersGetter) {
    var key, result = [];
    for (key in data) {
      if (data.hasOwnProperty(key)) {
        result.push(encodeURIComponent(key) + "=" + encodeURIComponent(data[key]));
      }
    }
    return result.join("&");
  });
  // Add the interceptor to the $httpProvider.
  $httpProvider.interceptors.push('WsHttpInterceptor');
}])
.run(function($ionicPlatform, $rootScope, $ionicLoading) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      StatusBar.styleDefault();
    }
    
    // init admob
    /*
    if(window.plugins && window.plugins.AdMob) {
        var admob_key = device.platform == "Android" ? "ANDROID_PUBLISHER_KEY" : "IOS_PUBLISHER_KEY";
        var admob = window.plugins.AdMob;
        admob.createBannerView( 
            {
                'publisherId': admob_key,
                'adSize': admob.AD_SIZE.BANNER,
                'bannerAtTop': false
            }, 
            function() {
                admob.requestAd(
                    { 'isTesting': false }, 
                    function() {
                        admob.showAd(true);
                    }, 
                    function() { console.log('failed to request ad'); }
                );
            }, 
            function() { console.log('failed to create banner view'); }
        );
    }    
        */
    // init admob - pro  
    if ( window.AdMob || AdMob) {
           // console.log(window.AdMob);
    	    var ad_units = {
				/*ios : {
					banner: 'ca-app-pub-6869992474017983/4806197152',
					interstitial: 'ca-app-pub-6869992474017983/7563979554'
				},*/
				android : {
					banner: 'ca-app-pub-3547412796652184/4114506159',
					interstitial: 'ca-app-pub-3547412796652184/1800168159'
				}/*,
				wp8 : {
					banner: 'ca-app-pub-6869992474017983/8878394753',
					interstitial: 'ca-app-pub-6869992474017983/1355127956'
				}*/
    	    };
    	    var admobid = "";
    	    if( /(android)/i.test(navigator.userAgent) ) {
    	    	admobid = ad_units.android;
    	    } else if(/(iphone|ipad)/i.test(navigator.userAgent)) {
    	    	admobid = ad_units.ios;
    	    } else {
    	    	admobid = ad_units.wp8;
    	    }
            if(AdMob) AdMob.createBanner( {adId: admobid.banner, position: AdMob.AD_POSITION.BOTTOM_CENTER, autoShow: true } );      
            // preppare and load ad resource in background, e.g. at begining of game level
            if(AdMob) AdMob.prepareInterstitial( {adId:admobid.interstitial, autoShow:false} );

            // show the interstitial later, e.g. at end of game level
            //if(AdMob) AdMob.showInterstitial();
     }            
        

    // global loading functions
    /**/  
    $rootScope.$on('loading:show', function() {
      console.log('foo show'); 
      $ionicLoading.show({template: '<div class="loader"><div class="spinner"><div class="rect1"></div> <div class="rect2"></div> <div class="rect3"></div> <div class="rect4"></div> <div class="rect5"></div></div></div>'});
     /* $ionicLoading.show({
            templateUrl: 'templates/loading-icon.html'
        });         */
    });
    $rootScope.$on('loading:hide', function() {
      console.log('foo hide');
      $ionicLoading.hide();
    });   
  });
})
.config(function($stateProvider, $urlRouterProvider) {
 $stateProvider
    .state('auth', {
      url: "/auth",
      cache: false,
      templateUrl: "templates/auth.html",
      controller: 'AuthCtrl'
    })
    .state('signin', {
      url: "/sign-in",
      templateUrl: "templates/user-sign-in.html",
      controller: 'SignInCtrl'
    })
    .state('signup', {
      url: "/sign-up",
      templateUrl: "templates/user-sign-up.html",
      controller: 'SignUpCtrl'
    })
    .state('password', {
      url: "/password",
      templateUrl: "templates/user-password.html",
      controller: 'PasswordCtrl'
    })         
    .state('app', {
      url: "/app",
      abstract: true, // abstract state for the side menu
      templateUrl: "templates/menu.html",
      controller: 'AppCtrl'
    })    
    .state('app.dashboard', {
      url: "/dashboard",
      cache: false,
      views: {
             'main': {
               templateUrl: "templates/user-dashboard.html",
               controller: 'DashCtrl'//,
               //resolve: {
                   //     scheduleData: function(DashService) {
                   //       return DashService.updateSchedules();
                   //     }
                   //   }               
            }
        }      
    }) 
   .state('app.profile', {
      url: "/profile",
      cache: false,
        views: {
             'main': {
               templateUrl: "templates/profile.html",
               controller: 'ProfileCtrl'/*,
               resolve: {
                        settings: function(UserService) {
                          return UserService.getSettings();
                        }
                      }*/
            }
        }   
    })     
    .state('app.schedule', {
      url: "/schedule",
      abstract: true, // abstract state for the tabs directive
        views: {
             'main': {
               templateUrl: "templates/schedule.html"
            }
        }   
    })
    .state('app.schedule.workouts', {
        url: '/workouts',
        //cache: false,
        views: {
          'schedule-workouts': {
            templateUrl: 'templates/schedule-workouts.html',
            controller: 'ScheduleWorkoutCtrl'
          }
        }
      })
    .state('app.schedule.stats', {
        url: '/stats',
       // cache: false,
        views: {
          'schedule-stats': {
            templateUrl: 'templates/schedule-stats.html',
            controller: 'ScheduleStatsCtrl'//,
            /*resolve: {
                        settings: function(UserService) {
                          return UserService.getSettings();
                        }
                      }*/
          }
        }
      })
      .state('app.schedule.notes', {
        url: '/notes',
        // cache: false,
        views: {
          'schedule-notes': {
            templateUrl: 'templates/schedule-notes.html',
            controller: 'ScheduleNotesCtrl'
          }
        }
      })
    .state('app.calendars', {
      url: "/calendars",
      //cache: false,
        views: {
             'main': {
                templateUrl: "templates/calendars.html",
                controller: 'CalsCtrl'
            }
        }         
    })      
    .state('app.calendar', {
      url: "/calendar",
      cache: false,
        views: {
             'main': {
                templateUrl: "templates/calendar.html",
                controller: 'CalCtrl'
            }
        }    
    })      
    .state('app.create-schedule', {
      url: "/create-schedule",
        views: {
             'main': {
                templateUrl: "templates/schedule-create.html"
            }
        }    
    })  
    ;      
  $urlRouterProvider.otherwise("/auth");    
});
