angular.module('wsmob.filters', [])
.filter('weightLabel', function () {
 /* --------------------------------------------  
 | Filter creates weigth label based on supplied units setting
 */ 
    return function (units) {
        if(units === 'kg/cm'){
            return '(kg)';
        }else{
            return '(lb)';
        }
    };
})
.filter('lengthLabel', function () {
/* --------------------------------------------  
 | Filter creates length label based on supplied units setting
 */ 
    return function (units) {
        if(units === 'kg/cm'){
            return '(cm)';
        }else{
            return '(in)';
        }
    };
})
.filter('weightConvert', function () {
/* --------------------------------------------  
 | Filter converts weight based on supplied units setting
 */     
    return function (value, units) {
        console.log('weightConvert',value,units);
        if(units === 'kg/cm'){
            return (value / 2.20462).toFixed(1);
        }else{
            return value.toFixed(1);
        }
    };
})
.filter('lengthConvert', function () {
/* --------------------------------------------  
 | Filter converts length based on supplied units setting
 */      
    return function (value, units) {
        console.log('lengthConvert',value,units);
        if(units === 'kg/cm'){            
            return (value * 2.54).toFixed(1);
        }else{
            return value.toFixed(1);
        }
    };
});



