angular.module('wsmob.services', [])
.factory('UtilService', function() {})
.factory('UserService', function($http, $q) {  
/* --------------------------------------------  
 | Service for managing user data
 */      
     // init service object and functions
     var service = {
                   //user: [],
                   settings: [],
                   getUser : getUser,
                   setUser : setUser,
                   getSettings : getSettings,
                   setSettings : setSettings,
                   signIn : signIn,
                   signUp : signUp,
                   signOut : signOut,
                   recoverPassword : recoverPassword,
                   getCookie : getCookie,
                   setCookie : setCookie,
                   validateCookie : validateCookie
                   };
    return service;  

                // get user from local storage
                function getUser() {           
                  var user = JSON.parse(localStorage.getItem('user'));
                  return user;
                }
                
                // set user in local storage
                function setUser(user) {                   
                  localStorage.setItem('user', JSON.stringify(user) ); 
                  return  true;    
                }  
                
                // get settings
                function getSettings() {       
                 // var settings = JSON.parse(localStorage.getItem('settings')); // get settings from local storage
                  var deferred = $q.defer(); // init promise object
                  
                  // local storage settings re null, so connect to api
                  //if(settings === null){
                        var user = this.getUser(); // get user
                        // connect to server using user credentials
                        $http.post('http://workoutscheduler.net/app-data/wsmobile/get_user_meta/?', { user_id : user.id })
                        .then(function(settingsData) {
                              console.log('UserService getSettings()  remote data present', settingsData);
                              if (settingsData.data.status === 'ok'){  
                                    // settings retrived - store settings in local storage and resolve promise
                                    localStorage.setItem('settings', JSON.stringify(settingsData.data.settings));
                                    deferred.resolve(settingsData.data.settings);
                              }else{
                                  // settings not retrieved - reject promise
                                  deferred.reject({error : settingsData.data.error});
                              }
                        })
                        .catch(function(error) {
                            // data error - reject promise
                            deferred.reject({error : "Data error. Please check your data connection."});
                        }); 
                  /*  
                 }else{
                    //local settings found - resolve promise  
                    console.log('UserService getSettings()  local data present', settings);   
                    deferred.resolve(settings);               
                  }*/
                   return deferred.promise; // rteurn promise object
                }
                
                // set settings
                function setSettings(settings) {  
                    console.log('UserService setSettings()', settings);
                    var deferred = $q.defer();  // init promise object
                    var user = this.getUser(); // get user 
                    localStorage.setItem('settings', JSON.stringify(settings));// store settings locally first
                    
                    // submit settings to server/api
                    $http.post('http://workoutscheduler.net/app-data/wsmobile/update_user_meta/?', {
                                                                                                    user_id : user.id,
                                                                                                    dob : settings.dob,
                                                                                                    units : settings.units,
                                                                                                    gender : settings.gender,
                                                                                                    height : settings.height
                                                                                                    })
                    .then(function(settingsData) {
                          console.log(settingsData);
                          if (settingsData.data.status === 'ok'){  
                                // settings saved - store updated settings in local storage and resolve promise
                                localStorage.setItem('settings', JSON.stringify(settingsData.data.settings));
                                deferred.resolve(settingsData.data.settings); // resolve promise
                          }else{
                              // settings not saved - reject promise
                              deferred.reject({error : settingsData.data.error});
                          }
                    })
                    .catch(function(error) {
                        // data error, settings not saved - reject promise
                        deferred.reject({error : "Data error. Please check your data connection."});
                    });   
                    return deferred.promise;// return promise
                }
                
                // sign in user
                function signIn(username, password){                            
                    var deferred = $q.defer();  // init promise object
                    var self = this; // assign this to variable
                    
                    // get auth cookie
                    $http.post('http://workoutscheduler.net/app-data/get_nonce/?controller=auth&method=generate_auth_cookie')
                    .then(function(authCookie) {
                          if (authCookie.data.status === 'ok'){
                             // cookie recieved - submit credentials to server/api
                             return $http.post('http://workoutscheduler.net/app-data/auth/generate_auth_cookie/?nonce='+authCookie.data.nonce+'&username='+username+'&password='+password);
                          }else{
                              // could not retrieve cookie - reject promse
                              deferred.reject({error : "Could not authenticate user."});
                          }
                    })
                    .then(function(authUser) {                      
                          if (authUser.data.status === 'ok'){
                                // crednetials were okay - set user / cookie and resolve promise
                                self.setUser(authUser.data.user);
                                self.setCookie(authUser.data.cookie);
                                deferred.resolve(authUser);
                          }else{
                                // could not sign in - reject promse
                                deferred.reject({error : "Login information could not be authenticated."});
                          }
                    })
                    .catch(function(error) {
                        // could not connect to server - reject promse
                        deferred.reject({error : "Data error. Please check your data connection."});
                    });                               
                    return deferred.promise; // return promise
                }
                
                // sign out user
                function signOut(){
                   // destroy all local user data and return true
                   localStorage.removeItem('cookie');
                   localStorage.removeItem('user');
                   localStorage.removeItem('settings');
                   return true;
                }
                
                // sign up user
                function signUp(username, password, email){                    
                    var deferred = $q.defer();  // init promise object
                    var self = this; // assign this to variable
                    
                    // get new user nonce
                    $http.post('http://workoutscheduler.net/app-data/get_nonce/?controller=user&method=register')
                    .then(function(registerData) {
                          if (registerData.data.status === 'ok'){    
                              // submit new user credentials to server/api
                              return $http.post('http://workoutscheduler.net/app-data/wsmobile/sign_up/?username='+username+'&password='+password+'&email='+email);
                          }else{
                              // nonce was not okay - reject promise
                              deferred.reject({error : "Could not validate user registeration. ".registerData.data.error });
                          }
                    })
                    .then(function(registerUser) {                       
                          if (registerUser.data.status === 'ok'){                              
                                // new user crednetials were okay - resolve promise
                                deferred.resolve(registerUser);
                          }else{
                                // new user crednetials were not okay - reject promise
                                deferred.reject({error : registerUser.data.error });
                          }
                    })
                    .catch(function(error) {
                        // data error - reject promise
                        deferred.reject({error : "Data error. Please check your data connection."});
                    });           
                    
                    return deferred.promise; // return promise
                }    
                
                // recover user password
                function  recoverPassword(username){                    
                    var deferred = $q.defer();  // init promise object
                    // submit username to server/api
                    $http.post('http://workoutscheduler.net/app-data/wsmobile/recover_password/?user='+username)
                    .then(function(passwordData) {
                          if (passwordData.data.status === 'ok'){  
                                // username was okay - resolve promise
                                deferred.resolve(passwordData);
                          }else{
                              // username was not okay - reject promise
                              deferred.reject({error : passwordData.data.error});
                          }
                    })
                    .catch(function(error) {
                        // data error - reject promise
                        deferred.reject({error : "Data error. Please check your data connection."});
                    });   
                    return deferred.promise; // return promise
                }    
                
                // get cookie from local storage
                function getCookie() {                   
                  var cookie = localStorage.getItem('cookie');  
                  return cookie;    
                }
                
                // set cookie in local storage
                function  setCookie(cookie) {                   
                  localStorage.setItem('cookie', cookie);
                  return  true;    
                }    
                
                // validate user cookie
                function validateCookie(){
                    var deferred = $q.defer();// init promise object
                    var cookie = this.getCookie();// get stored cookie
                      // submit stored cookie to server/api
                      $http.post('http://workoutscheduler.net/app-data/auth/validate_auth_cookie/?cookie='+cookie)
                      .success(function(data, status, headers, config) { 
                              // cookie was okay - resolve promise
                              deferred.resolve(data);                   
                         }).error(function(data, status) {            
                             // cookie was not okay - reject promise
                              deferred.reject({error : "Data error. Please check your data connection."});
                         });  
                    return deferred.promise; // return promise
                }    
})
.factory('CalendarService', function($http, $q, UserService) {
 /* --------------------------------------------  
 | Service for managing calendars
 */      
     // init user object and  service object/functions
     var user =  UserService.getUser();        
     var service = {
                   calendar: [],
                   calendarsData: [],
                   calendarData: [],
                   getCalendar : getCalendar,
                   setCalendar : setCalendar,
                   getCalendars : getCalendars,
                   getCalendarData : getCalendarData,
                   createSchedule : createSchedule
                   };
    return service;  
     
    // get current calendar variable 
    function getCalendar() {                                     
      return  calendar;    
    }
    
    // set current calendar variable 
    function setCalendar(calObj) {   
       calendar = calObj;  
    }
    
    // return all available user calendars
    function getCalendars() {                                     
        var deferred = $q.defer();// init promise object
             // request user calendars from api
              $http.post('http://workoutscheduler.net/app-data/wsmobile/get_workout_calendars/?id='+user.id)
              .success(function(data, status, headers, config) {
                     if (data.status === 'ok'){                         
                        // calendars returned, copy data to service object - resolve promise
                        angular.copy(data, service.calendarsData);
                        deferred.resolve(service.calendarsData);
                     }else{ 
                        // calendars not returned - reject promise             
                        deferred.reject({error : "An error occured while fetching schedules."});
                     }                       
                 }).error(function(data, status) {                                    
                      // data error - reject promise             
                      deferred.reject({error :"Data error. Please check your data connection."});
                 });  
            return deferred.promise;  // return promise  
    }    
    
    // return selected calendar data
    function getCalendarData(){
        var deferred = $q.defer();// init promise object
          //$http.post('http://workoutscheduler.net/app-data/wsmobile/get_workout_calendar/?id='+calendar.id)
          $http.post('http://workoutscheduler.net/app-data/wsmobile/get_workout_calendar/?id='+calendar.id)
          .success(function(data, status, headers, config) {
                 if (data.status === 'ok'){         
                    // calendar data not returned - resolve promise 
                    angular.copy(data, service.calendarData);
                    deferred.resolve(service.calendarData);
                 }else{  
                    // calendar data not returned - reject promise   
                    deferred.reject({error : "An error occured while fetching schedules"});
                 }                       
             }).error(function(data, status) {                                    
                  // data error - reject promise     
                  deferred.reject({error :"Data error. Please check your data connection."});
             });  
        return deferred.promise;// return promise
    }
    
    // create new user schedule
    function createSchedule(){ 
        var deferred = $q.defer();// init promise object
        var self = this; // assign this to variable

            // get create schedule nonce from api
            $http.post('http://workoutscheduler.net/app-data/get_nonce/?controller=wsmobile&method=create_schedule')
            .then(function(scheduleNonce) {
                  if (scheduleNonce.data.status === 'ok'){    
                        // nonce recieved - create schedule
                        return $http.post('http://workoutscheduler.net/app-data/wsmobile/create_schedule/',{
                                                                                                            author_id : user.id,
                                                                                                            nonce : scheduleNonce.data.nonce,
                                                                                                            calid : self.calendarData.id,
                                                                                                            title : self.calendarData.title
                                                                                                           });
                  }else{
                      // nonce error - reject promise
                      deferred.reject({error : "Could not auhtorise request."});
                  }
            })
            .then(function(newSchedule) {                        
                  if (newSchedule.data.status === 'ok'){
                     // new schedule added - resolve promise   
                     deferred.resolve(newSchedule);
                  }else{
                     // new schedule not added - reject promise
                     deferred.reject({error : "Schedule could not be created."});
                  }
            })
            .catch(function(error) {
                // data error - reject promise
                deferred.reject({error : "Data error. Please check your data connection."});
            });
        return deferred.promise; // return promise                   
    } 
               
})
.factory('ScheduleService', function($http, $q) {  
/* --------------------------------------------  
 | Service for managing schedules
 */          
    // init service object and functions
    var service = {
                   schedule: [],
                   scheduleData: [],
                   getSchedule : getSchedule,
                   setSchedule : setSchedule,
                   getScheduleData : getScheduleData,
                   deleteSchedule : deleteSchedule,
                   updateScheduleWorkouts : updateScheduleWorkouts,
                   updateScheduleNotes : updateScheduleNotes,
                   updateScheduleStats : updateScheduleStats//,
                   //updateScheduleSettings : updateScheduleSettings
                   };
    return service;      
     
    // get selected schedule
    function getSchedule() {                                     
               return  schedule; 
            }
    // set a current schedule
    function setSchedule (scheduleObj) {   
               schedule = scheduleObj;  
            }
    // get current schedule data        
    function getScheduleData(){
          var deferred = $q.defer();// init promise object
          
          // rquest schedule data from api
          $http.post('http://workoutscheduler.net/app-data/wsmobile/get_workout_schedule/?id='+schedule.id)
          .success(function(data, status, headers, config) {
                 if (data.status === 'ok'){   
                    // schedule returned - copy data to service object and resolve promise
                    angular.copy(data, service.scheduleData);
                    deferred.resolve(service.scheduleData);
                 } else {              
                     // schedule not returned - reject promise 
                    deferred.reject({error : "An error occured while fetching the selected schedule"});
                 }                       
             }).error(function(data, status) {  
                  // data error - reject promise 
                  deferred.reject({error :"Data error. Please check your data connection."});
             });  
        return deferred.promise;// return promise
    }    
    
    // delete schedule
    function  deleteSchedule(scheduleObj) {   
           console.log('ScheduleService deleteSchedule', scheduleObj);  
           
            var deferred = $q.defer();// init promise object           
            
              // send schedule id to api for delete
              $http.post('http://workoutscheduler.net/app-data/wsmobile/delete_workout_schedule/?id='+scheduleObj.id)
              .success(function(data, status, headers, config) {
                     if (data.status === 'ok'){   
                         // schedule deleted - resolve promise
                         deferred.resolve(data);
                     } else  {              
                        // schedule not deleted - reject promise
                        deferred.reject({error : "An error occured while deleting the schedule." + data.error});
                     }                       
                 }).error(function(data, status) {    
                      // data error - reject promise
                      deferred.reject({error :"Data error. Please check your data connection."});
                 });  
            return deferred.promise; // return promise   
    }
    
    // update schedule workouts
    function updateScheduleWorkouts(){     
            var deferred = $q.defer();// init promise object            
            var updateData = angular.toJson(this.scheduleData.schedule); // parse schedule variable/object to json string for update
            
              // send schedule update data to api for update
              $http.post('http://workoutscheduler.net/app-data/wsmobile/update_workout_schedule/?id='+this.scheduleData.id, {schedule : updateData})
              .success(function(data, status, headers, config) {
                     if (data.status === 'ok'){   
                        // schedule updated - resolve promise
                        deferred.resolve(data);
                     } else {      
                        // schedule not updated - reject promise 
                        deferred.reject({error : "An error occured while updating the selected schedule"});
                     }                       
                 }).error(function(data, status) {  
                      // data error - reject promise
                      deferred.reject({error :"Data error. Please check your data connection."});
                 });  
            return deferred.promise;  // return promise
        
    }       
    function updateScheduleNotes(){     
            var deferred = $q.defer();// init promise object
            var updateData = angular.toJson(this.scheduleData.notes);// parse schedule variable/object to json string for update
            
              // send schedule update data to api for update
              $http.post('http://workoutscheduler.net/app-data/wsmobile/update_workout_schedule/?id='+this.scheduleData.id, {notes : updateData})
              .success(function(data, status, headers, config) {
                     if (data.status === 'ok'){   
                         // schedule updated - resolve promise
                         deferred.resolve(data);
                     } else {    
                        // schedule not updated - reject promise  
                        deferred.reject({error : "An error occured while updating the selected schedule notes"});
                     }                       
                 }).error(function(data, status) { 
                      // data error - reject promise
                      deferred.reject({error :"Data error. Please check your data connection."});
                 });  
            return deferred.promise;  // return promise
    }          
    
     function updateScheduleStats(){     
            var deferred = $q.defer();// init promise object
            var updateData = angular.toJson(this.scheduleData.stats); // parse schedule variable/object to json string for update
            
              // send schedule update data to api for update
              $http.post('http://workoutscheduler.net/app-data/wsmobile/update_workout_schedule/?id='+this.scheduleData.id, {stats : updateData})
              .success(function(data, status, headers, config) {
                     if (data.status === 'ok'){   
                         // schedule updated - resolve promise
                         deferred.resolve(data);
                     } else {       
                        // schedule not updated - reject promise 
                        deferred.reject({error : "An error occured while updating the selected schedule notes"});
                     }                       
                 }).error(function(data, status) {  
                      // data error - reject promise
                      deferred.reject({error :"Data error. Please check your data connection."});
                 });  
            return deferred.promise;  // return promise
    }   
    /*
     function updateScheduleSettings(){     
            var deferred = $q.defer();// init promise object
           
              $http.post('http://workoutscheduler.net/app-data/wsmobile/update_workout_schedule_settings/?id='+this.scheduleData.id, {height : this.scheduleData.height, gender : this.scheduleData.gender,units : this.scheduleData.units})
              .success(function(data, status, headers, config) {
                     if (data.status === 'ok') {   
                          deferred.resolve(data);
                     } else  {              
                        deferred.reject({error : "An error occured while updating the selected schedule settings"});
                     }                       
                 }).error(function(data, status) {   
                      deferred.reject({error :"Data error. Please check your data connection."});
                 });  
            return deferred.promise;  // return promise
    } */       
})
.factory('DashService', function($http, $q, UserService) {
/* --------------------------------------------  
 | Service for managing dashboard schedules
 */       
    // init user object and  service object/functions   
    var user =  UserService.getUser();    
    var service = {
                   schedulesData: [],
                   updateSchedules : updateSchedules
                   };
    return service;  

    // update dash schedules
    function updateSchedules() {
          var deferred = $q.defer();// init promise object

          // get user schedule from api
          $http.post('http://workoutscheduler.net/app-data/wsmobile/get_schedules/?author_id='+user.id)
          .success(function(data, status, headers, config) {
                 if (data.status === 'ok'){    
                     // schedules returned - copy data to service object and resolve promise
                     angular.copy(data, service.schedulesData);
                     deferred.resolve(data);
                 } else {              
                    // schedules not returned - reject promise
                    deferred.reject("An error occured while fetching schedules");
                 }                       
             }).error(function(data, status) {                                    
                 // data error - reject promise
                 deferred.reject("Data error. Please check your data connection.");
             });  
        return deferred.promise;// return promise
    }          
});
